=== debian/changelog ===
libomemo (0.6.2+git20200527.e3b212-2pureos+librem5.1) amber-phone; urgency=medium

  * Upload to amber-phone
  * d/control: Use dh12
  * debian/gbp.conf: Adjust to pureos amber
  * debian: Add gitlab-ci

 -- Guido Günther <agx@sigxcpu.org>  Sun, 22 Nov 2020 18:48:28 +0100

libomemo (0.6.2+git20200527.e3b212-2) unstable; urgency=low

  [Evangelos Ribeiro Tzaras]
  * Add 12byte IVs patch for compatibility with other XMPP clients
  * Note the forwarded patches

  [Federico Ceratto]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Mon, 16 Nov 2020 19:36:10 +0100

libomemo (0.6.2+git20200527.e3b212-1) unstable; urgency=medium

  * Initial Debian release (Closes: #926344)

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Wed, 27 May 2020 17:24:35 +0200
