=== debian/control ===
Source: libomemo
Section: libs
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders:
 Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
Build-Depends:
 debhelper-compat (= 12),
 libcmocka-dev,
 libgcrypt20-dev,
 libglib2.0-dev,
 libmxml-dev,
 libsqlite3-dev,
 pkg-config,
Standards-Version: 4.5.0
Homepage: https://github.com/gkdr/libomemo
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/libomemo
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/libomemo.git
Rules-Requires-Root: no

Package: libomemo-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libglib2.0-dev,
 libomemo0 (= ${binary:Version}),
 ${misc:Depends},
Description: Library implementing OMEMO (XEP-0384) (development headers)
 OMEMO is an XMPP Extension Protocol (XEP) for secure multi-client
 end-to-end encryption. It is based on Double Ratched and PEP.
 .
 This package contains the development files.

Package: libomemo0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library implementing OMEMO (XEP-0384)
 OMEMO is an XMPP Extension Protocol (XEP) for secure multi-client
 end-to-end encryption. It is based on Double Ratched and PEP.
 .
 This package contains the shared library.
