=== debian/changelog ===
libomemo (0.7.0-1) unstable; urgency=medium

  [Evangelos Ribeiro Tzaras]
  * Update to upstream v0.7.0
  * Remove upstreamed patches

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Sun, 06 Dec 2020 13:03:46 +0100
