=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libcmocka-dev,
  libgcrypt20-dev,
  libglib2.0-dev,
