=== debian/changelog ===
libomemo (0.8.1-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:25:01 +0000

libomemo (0.8.1-3build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:27:22 +0000

libomemo (0.8.1-3) unstable; urgency=medium

  * d/control: Add Breaks/Replaces on libomemo-dev
    which shipped link to shared object

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Sun, 07 May 2023 11:27:30 +0200

libomemo (0.8.1-2) unstable; urgency=medium

  * Team upload.
  * libomemo0: move libomemo.so back to -dev package (Closes: #1034996)

 -- Arnaud Ferraris <aferraris@debian.org>  Sun, 07 May 2023 10:51:51 +0200

libomemo (0.8.1-1) unstable; urgency=medium

  * Use better git-buildpackage defaults
  * Remove obsolete patches
  * Update symbols
  * Add copyright helper script
  * Adjust rules for cmake based build (not Makefiles)
  * Adjust installed files
  * Add cmake build dependency
  * Update copyright
  * Declare compliance with Debian Policy 4.6.1

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Fri, 27 May 2022 08:33:03 +0200

libomemo (0.7.0-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix cross-misbuild: Derive the multiarch triplet from the host CC.
    (Closes: #1003476)

  [ Evangelos Ribeiro Tzaras ]
  * CI: disable aptly
  * d/patches: Unbreak parallel builds

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Thu, 13 Jan 2022 12:03:10 +0100
