=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: libomemo
 Section: libs
 Priority: optional
-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders:
  Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
  libcmocka-dev,
  libgcrypt20-dev,
@@ -12,13 +14,15 @@
  libmxml-dev,
  libsqlite3-dev,
  pkg-config,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/gkdr/libomemo
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/libomemo
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/libomemo.git
 Rules-Requires-Root: no
 
 Package: libomemo-dev
+Breaks: libomemo0 (<= 0.8.1-2)
+Replaces: libomemo0 (<= 0.8.1-2) 
 Section: libdevel
 Architecture: any
 Multi-Arch: same
