=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libomemo-$1\.tar\.gz/ \
  https://github.com/gkdr/libomemo/tags .*/v?(\d\S+)\.tar\.gz
